/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Samucaya Search Sidebar.
 *
 * The Initial Developer of the Original Code is
 * Vilas Athavale (vilas@samucaya.com)
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var version = "v201";

var eventElements = new Array();
var driverArray = new Array();
var urlArray = new Array();
var resultArray = new Array();

var currentDriverPosn = 0;
var currentLoading = "";

var samucayaSidebarElement = null;

var currentProcessingSource = null;

var loadingFirstPage = false;

const NOTIFY_STATE_DOCUMENT =
  Components.interfaces.nsIWebProgressListener.NOTIFY_STATE_DOCUMENT;
const STATE_IS_DOCUMENT =
  Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT;
const STATE_START =
  Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP =
  Components.interfaces.nsIWebProgressListener.STATE_STOP;
  
function SamucayaDriver() {
	var type;
	var value;
	var xpath;
	var formValue;
	var url;
	var text;
	var href;
	var waitWhile;
	var newTab;
	var elementId;
	var processingSource;
}


var myProgressListener =
{

  onStateChange:function(aProgress,aRequest,aFlag,aStatus)
  {
     try {
     	aRequest.QueryInterface(Components.interfaces.nsIChannel);
     } catch (e) {
	return;
     }
    
    aRequest.QueryInterface(Components.interfaces.nsIChannel);
    if(aFlag & STATE_STOP) {
      if (loadingFirstPage == true) {
	var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
				   .getInterface(Components.interfaces.nsIWebNavigation)
				   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
				   .rootTreeItem
				   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
				   .getInterface(Components.interfaces.nsIDOMWindow);

	var tabbedBrowser = mainWindow.getBrowser();

        tabbedBrowser.removeProgressListener(myProgressListener, NOTIFY_STATE_DOCUMENT);

      	loadingFirstPage = false;
      	// now register click.
      	var p = 1;
	var x = content.document.getElementById("samucayaProperOpen");
	if (x != null) {
		x.setAttribute("status", "true");
	}
	
      	while (true) {
      		e1 = content.document.getElementById("samucayaresult"+p);
      		if (e1 == null) {
      			break;
      		}
      			e1.addEventListener("click", SamucayaSearchObj.click, false);
      		p++;
      	}
      } else {
	      urlArray.splice(0, 1);
	      if (urlArray.length == 0) {
		SamucayaSearchObj.executeDriver();
		currentLoading = "";
	      }
      }
    } else if (aFlag & STATE_START) {
	if (loadingFirstPage != true) {
	      	urlArray[urlArray.length] = aRequest.URI.spec;
	}
    }
  },
  
  onLocationChange:function(a,b,c){},
  onProgressChange:function(a,b,c,d,e,f){},
  onStatusChange:function(a,b,c,d){},
  onSecurityChange:function(a,b,c){},

  /*XXX
    This is not nsIWebProgressListenr method,
    just killing a error in tabbrowser.xml
    Maybe a bug.
  */
  onLinkIconAvailable:function(a){}
};

function xpathAndValue() {
	var xpath;
	var value;
}

var SamucayaSearchObj = {


executeDriver : function() {
//  var tabbedBrowser = top.document.getElementById("content");
  var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);

  var tabbedBrowser = mainWindow.getBrowser();
	var doc = content.document;
	for ( ;currentDriverPosn < driverArray.length; ) {
		var posn = currentDriverPosn;
		var driverEntry = driverArray[posn];
		var c = driverEntry.processingSource;
		if (c != null && c != currentProcessingSource) {
			currentProcessingSource = c;
			if (samucayaSidebarElement != null) {
				samucayaSidebarElement.setAttribute("currentProcessingSource", currentProcessingSource);
			}
			SamucayaSearchObj.updateSidebarStatus();
		}
		if (driverEntry.waitWhile != null) {
			if (doc.getElementById(driverEntry.waitWhile)) {
				return;
			}
		}
		currentDriverPosn++;
		if (driverEntry.type == "url") {
			currentLoading = driverEntry.value;
			tabbedBrowser.loadURI(driverEntry.value);
			return;
		}
		
		if (driverEntry.type == "newTab") {
			  tabbedBrowser.selectedTab = tabbedBrowser.addTab("http://www.google.com");
			  return;
		}
		
		if (driverEntry.type == "stopListener") {
			tabbedBrowser.removeProgressListener(myProgressListener, NOTIFY_STATE_DOCUMENT);
			urlArray = new Array();
			continue;
		}
		
		if (driverEntry.type == "startListener") {
			tabbedBrowser.addProgressListener(myProgressListener, NOTIFY_STATE_DOCUMENT);
			urlArray = new Array();  
			continue;
		}
		
		if (driverEntry.type == "sleep") {
			SamucayaSearchObj.sleep(driverEntry.value);
			continue;
		}


		var nl = null;
		var res = null;
		if (driverEntry.elementId != null) {
			nl = doc.getElementById(driverEntry.elementId);
			res = nl;
			
		}
		
		if (nl == null) {
			nl = doc.evaluate(driverEntry.xpath, doc.documentElement, null, XPathResult.UNORDERED_NODE_ITERATOR_TYPE, null );
			res = nl.iterateNext();
		}
		
		if (nl != null) {
			if (res != null) {
				if (driverEntry.type == "input") {
					res.setAttribute("value", driverEntry.value);
				} 
				
				if (driverEntry.type == "radio") {
					res.value = driverEntry.value;
					res.click();	
				}				
				
				if (driverEntry.type == "select") {
						for (a=0; a < res.options.length; a++) {
							if (res.options[a].value != null && driverEntry.value != null) {
							if (res.options[a].value.indexOf(driverEntry.value) >= 0)  {
								res.options[a].selected = true;
								break;
							}
						}
					}
				}				


				if (driverEntry.type == "button") {
					if (driverEntry.value != null) {
						res.value = driverEntry.value;
					}
					
					//window.removeEventListener("click", SamucayaSearchObj.click, false);
					if (res.tagName.toUpperCase() == "A") {
						tabbedBrowser.loadURI(res.getAttribute("href"));
					} else {
						res.click();
					}
					//window.addEventListener("click", SamucayaSearchObj.click, false);
					return;
				}
				
				if (driverEntry.type == "extract") {
					var entry = new driver();
					entry.value = SamucayaSearchObj.getInnerText(res);
					var currentURI = getBrowser().currentURI;
					if (currentURI.port != -1) {
						url = url + ":" + currentURI.port;
					}
					var url = "http://" + currentURI.host;
					url = url + currentURI.path;
					entry.url = url;
					entry.href = driverEntry.text;
					resultArray[resultArray.length] = entry;
				}
				
			}
		}
	}

	SamucayaSearchObj.clearSidebarStatus();
},

sleep : function(value) {
   var req = false;
   try {
	   // branch for native XMLHttpRequest object
		if(window.XMLHttpRequest && !(window.ActiveXObject)) {
			try {
				req = new XMLHttpRequest();
			} catch(e) {
				req = false;
			}
		// branch for IE/Windows ActiveX version
		} else if(window.ActiveXObject) {
			try {
				req = new ActiveXObject("Msxml2.XMLHTTP");
			} catch(e) {
				try {
					req = new ActiveXObject("Microsoft.XMLHTTP");
				} catch(e) {
					req = false;
				}
			}
		}
		if(req) {
			req.overrideMimeType('text/xml');
			req.open("GET", "http://www.samucaya.com/php/"+version+"/sleep.php?sleep="+value, false);
			req.send("");
			
		}
	}
	catch (e) {
	}
},

buildDriver : function(doc, formposn) {
 	var iPosn = 0;
 	while(true) {
		var d = doc.getElementById("samucayaDriver"+ formposn + iPosn);
		iPosn++;
		if (d == null) {
			return;
		}

		var driverEntry = new SamucayaDriver();
		driverEntry.type = d.getAttribute("mytype");
		driverEntry.url = d.getAttribute("url");
		driverEntry.value = d.getAttribute("value");
		driverEntry.xpath = d.getAttribute("xpath");
		driverEntry.waitWhile = d.getAttribute("waitWhile");
		driverEntry.text = d.getAttribute("text");
		driverEntry.elementId = d.getAttribute("elementId");
		driverEntry.processingSource = d.getAttribute("processingSource");
		
		var mapId = d.getAttribute("mapId");
		if (mapId != null) {
			var ex = doc.getElementById(mapId);

			if (ex != null) {
				if (ex.tagName.toLowerCase() == "select") {
					driverEntry.value = ex.selectedIndex;
				} else {
					driverEntry.value = ex.value;
				}
			}
		}

		driverArray[driverArray.length] = driverEntry;
	}		
},


click : function(event) {
  var ele = event.target;
  var realClickedElement = ele;
  var doc = content.document;
//  var tabbedBrowser = top.document.getElementById("content");
  var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);

  var tabbedBrowser = mainWindow.getBrowser();
	
  tabbedBrowser.removeProgressListener(myProgressListener, NOTIFY_STATE_DOCUMENT);
  urlArray = new Array();

  driverArray = new Array();
  if (ele != null && ele.getAttribute("id") == "samucayaPageUnload") {
  	SamucayaSearchObj.unload(ele);
  }
  
  if (ele != null && ele.getAttribute("id").match("samucayaresult")) {
	// start driver
	var statusEle = ele.ownerDocument.getElementById("SamucayaStatus");
	if (statusEle.getAttribute('status') == "false") {
	  return;
	}
	
	currentDriverPosn = 0;
	SamucayaSearchObj.buildDriver(ele.ownerDocument, ele.getAttribute("formposn"));
	samucayaSidebarElement = ele.ownerDocument.getElementById("samucayaStatusFieldSet");
	currentProcessingSource = null;
	if (samucayaSidebarElement != null) {
		samucayaSidebarElement.setAttribute("currentProcessingSource", "");
	}
	SamucayaSearchObj.clearSidebarStatus();
	
	SamucayaSearchObj.executeDriver();
	return;
  } 
},

clearSidebarStatus : function() {
	var ele = document.getElementById("samucaya-panel");
	if (ele == null) {
		return;
	}
	ele.setAttribute("label", "");
},

updateSidebarStatus : function() {
	var ele = document.getElementById("samucaya-panel");
	if (ele == null) {
		return;
	}

	ele.setAttribute("label", "Searching ... " + currentProcessingSource);
},



getInnerText : function(el) 
  {
    if (typeof el == "string") return el;
    if (typeof el == "undefined") { return el };
    if (el.innerText) return el.innerText;  //Not needed but it is faster
    var str = "";
    
    var cs = el.childNodes;
    var l = cs.length;
    for (var i = 0; i < l; i++) {
      switch (cs[i].nodeType) {
        case 1: //ELEMENT_NODE
          str += this.getInnerText(cs[i]);
          break;
        case 3:  //TEXT_NODE
          str += cs[i].nodeValue;
          break;
      }
    }
    return str;
  },
  
  loadFirstPage : function() {
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIWebNavigation)
			   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
			   .rootTreeItem
			   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			   .getInterface(Components.interfaces.nsIDOMWindow);

    var tabbedBrowser = mainWindow.getBrowser();
    
    loadingFirstPage = true;
    
    tabbedBrowser.addProgressListener(myProgressListener, NOTIFY_STATE_DOCUMENT);
    tabbedBrowser.loadURI("http://www.samucaya.com/php/"+version+"/request.php");
    
	  	
  },
  
  init : function() {
      try {
        var aButtonId = "samucayaToolbarButton";
        var aElementId = "urlbar-container";
        
        if (!document.getElementById(aButtonId)) {
          var targetToolbarId = "nav-bar";
          var toolbar;
          var currentSet;
          var slicedCurrentSet;
          var targetIndex =  -1;
          var targetSet;
          var alreadySet = false;
          var toolbox = document.getElementById("navigator-toolbox");
  
          for (var i = 0, m = toolbox.childNodes.length; i < m; i++) {
            toolbar = toolbox.childNodes[i];
            // get the current set of the toolbar
            if (toolbar.hasAttribute("currentset")) {
              currentSet = toolbar.getAttribute("currentset");
            } else {
              currentSet = toolbar.getAttribute("defaultset");
            }
            slicedCurrentSet = currentSet.split(",");
            // find target on this toolbar and check whether the button
            // is on the toolbar or not.
            for (var j = 0, n = slicedCurrentSet.length; j < n; j++) {
              if (targetIndex == -1 && slicedCurrentSet[j] == aElementId) {
                targetIndex = j;
                targetSet = slicedCurrentSet;
                targetToolbarId = toolbar.id;
              }
              if (slicedCurrentSet[j] == aButtonId) {
                alreadySet = true;
                break;
              }
            }
          }
          // toolbars does not have the button
          if (!alreadySet) {
            // add the button id to the currentSet array
            if (targetIndex != -1) {
              targetSet.splice(targetIndex, 0, aButtonId);
            } else {
              targetSet.push(aButtonId);
            }
            // insert the button element to the toolbar
            var targetToolbar = document.getElementById(targetToolbarId);
            var targetElement = document.getElementById(aElementId);
            targetToolbar.setAttribute("currentset", targetSet.join());
            document.persist(targetToolbarId, "currentset");
  
            var mainPalette = toolbox.palette;
            var newButtonElement = null;
            for (var i = 0, m = mainPalette.childNodes.length; i < m; i++) {
              if (mainPalette.childNodes[i].id == aButtonId) {
                newButtonElement = mainPalette.childNodes[i].cloneNode(true);
                break;
              }
            }
  
            if ((newButtonElement != null) && (targetElement != null) &&
                 targetIndex != -1) {
               targetToolbar.insertBefore(newButtonElement, targetElement);
            } else if ((newButtonElement != null)) {
               targetToolbar.appendChild(newButtonElement);
            }
          }
        }
        // set the button state
        this.changeButtonState();
        this._setSidebarOpenState(null);
      } catch (e) {
        
      }

  },
  
  load : function() {
  },
  
  uload : function() {
  	
  },
  
  unload : function(unload) {
  	var doc = ele.ownerDocument;
      	var p = 1;
      	while (true) {
      		var e1 = doc.getElementById("samucayaresult"+p);
      		if (e1 == null) {
      			break;
      		}
      		e1.removeEventListener("click", SamucayaSearchObj.click, false);
      		p++;
      	}
  }
};


window.addEventListener("load", function(){ SamucayaSearchObj.init(); }, false);
